## Move_keyboard.py
#
#  Move Car with keyboard
#
####################################################
import PhysicsConstraints

##########################   Main

def main():

	# Get controller
	controller = GameLogic.getCurrentController()
	owner = controller.owner

	# Get vehicle constraint
	vehicle = ContrainteID(controller)
		
	# get pro Activ in Car
	propActiv = owner['Activ']
	
	if propActiv == 1:
		
		# Gas and Reverse
		Movements(vehicle, controller)
		
		# Direction
		Direction(vehicle, controller)

	return

##########################   Vehicle Constraint

# Get vehicle constraint
def ContrainteID(controller):

	# Get owner
	controller = GameLogic.getCurrentController()
	owner = controller.owner

	# Retrieve constraint ID you saved when wheels were attached
	constraint_ID = owner['constraint_ID']

	# get vehicle constraint
	vehicle = PhysicsConstraints.getVehicleConstraint(constraint_ID)

	return vehicle

##########################   Gas and reverse 
	
# Gas and reverse 	
def Movements( vehicle, controller):	

	# Set power amounts
	reculeForce = 200.0
	accelereForce = 400.0

	# Get power sensors
	accelere = controller.sensors["up key"]
	recule = controller.sensors["down key"]
	
	vitesse = 0.0
			
	# Reverse
	if recule.positive :
		
		vitesse = reculeForce
	
	# Gas pedal
	elif accelere.positive :
		
		vitesse = -accelereForce

	# Apply to all four tires
	vehicle.applyEngineForce(vitesse, 0)
	vehicle.applyEngineForce(vitesse, 1)
	vehicle.applyEngineForce(vitesse, 2)
	vehicle.applyEngineForce(vitesse, 3)				 					
		
##########################   Direction

def Direction( vehicle, controller):

	# Set turn amount
	direction = 0.3
	
	# Get steering sensors
	virageGauche = controller.sensors["left"]
	virageDroite = controller.sensors["right"]
		
	# Turn left	
	if virageGauche.positive :
		
		direction = direction
	
	# Turn right	
	elif virageDroite.positive :
		
		direction = -direction
	
	# Go straight	
	else:
		direction = 0.0

	# Turn with Front Tire
	vehicle.setSteeringValue(direction,0)
	vehicle.setSteeringValue(direction,1)

##########################   
main()   
