##### Suspension.py
#
#  Set interactive suspension
#
####################################################

# import PhysicsConstraints
import PhysicsConstraints

# Get owner
controller = GameLogic.getCurrentController()
owner = controller.owner

##########################################################
# SuspensionCompression
##########################################################
# get prop a = BoutonA Local Position 26.14 < a < 26.69
a = owner['a']

# and set SuspComp = 0.04 to 20.0
SuspComp = 36 * ( a  - 26.141 )

if SuspComp < 0 :
	SuspComp = 0.0

#print "1 - SuspComp = 0.04 to 20.0 ==   ", SuspComp

##########################################################
# SuspensionDamping
##########################################################
# get prop b = BoutonB Local Position 26.14 < b < 26.69
b = owner['b']

# and set SuspDamp = 0.00 to 50.0
SuspDamp = 91 * ( b  - 26.141 )

if SuspDamp < 0 :
	SuspDamp = 0.0

#print "Amortissemnet- SuspDamp = 0.00 to 50.0 ==   ", SuspDamp

##########################################################
# SuspensionStiffness
##########################################################
# get prop c = BoutonC Local Position 26.14 < c < 26.69
c = owner['c']

# and set SuspStiff = 0.0 to 80.0
SuspStiff = 145 * ( c  - 26.141 )

if SuspStiff < 0 :
	SuspStiff = 0.0

#print "Raideur - SuspStiff = 0.0 to 80.0 ==   ", SuspStiff

##########################################################
# RollInfluence
##########################################################
# get prop d = BoutonD Local Position 26.14 < d < 26.69
d = owner['d']

# and set Roll = 0.00 to 0.44
Roll = 0.8 * ( d  - 26.141 )

if Roll < 0 :
	Roll = 0.0

#print "Roll = 0.00 to 0.44 ==", Roll

##########################################################
# TyreFriction
##########################################################
# get prop e = BoutonE Local Position 26.14 < e < 26.69
e = owner['e']

# and set TyreFrict = 0.00 to 5.2
TyreFrict = 9.5 * ( e  - 26.141 )

if TyreFrict < 0 :
	TyreFrict = 0.0

#print "TyreFrict = 0.00 to 5.2 ==", TyreFrict

####################################################################################################################
# Retrieve constraint ID you saved when wheels were attached
constraint_ID = owner['constraint_ID']

# get the vehicle constraint
vehicle = PhysicsConstraints.getVehicleConstraint(constraint_ID)

####################################################################################################################
# Set Suspension Compression
vehicle.setSuspensionCompression(SuspComp, 0)
vehicle.setSuspensionCompression(SuspComp, 1)
vehicle.setSuspensionCompression(SuspComp, 2)
vehicle.setSuspensionCompression(SuspComp, 3)

##########################################################	
# Set Suspension Damping
vehicle.setSuspensionDamping(SuspDamp, 0)
vehicle.setSuspensionDamping(SuspDamp, 1)
vehicle.setSuspensionDamping(SuspDamp, 2)
vehicle.setSuspensionDamping(SuspDamp, 3)

###########################################################
# Set Suspension Stiffness
vehicle.setSuspensionStiffness(SuspStiff, 0)
vehicle.setSuspensionStiffness(SuspStiff, 1)
vehicle.setSuspensionStiffness(SuspStiff, 2)
vehicle.setSuspensionStiffness(SuspStiff, 3)

############################################################
# Set Roll Influence
vehicle.setRollInfluence(Roll, 0)
vehicle.setRollInfluence(Roll, 1)
vehicle.setRollInfluence(Roll, 2)
vehicle.setRollInfluence(Roll, 3)

##########################################################
# Set Tyre Friction
vehicle.setTyreFriction(TyreFrict, 0)
vehicle.setTyreFriction(TyreFrict, 1)
vehicle.setTyreFriction(TyreFrict, 2)
vehicle.setTyreFriction(TyreFrict, 3)
